Makefile 34.9 KB
Newer Older
1
#
2 3 4
# This file is part of the flashrom project.
#
# Copyright (C) 2005 coresystems GmbH <stepan@coresystems.de>
5
# Copyright (C) 2009,2010,2012 Carl-Daniel Hailfinger
6 7 8 9 10 11 12 13 14 15 16 17 18
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
19
#
20

21
PROGRAM = flashrom
Ronald G. Minnich's avatar
Ronald G. Minnich committed
22

23 24 25 26 27 28
###############################################################################
# Defaults for the toolchain.

# If you want to cross-compile, just run e.g.
# make CC=i586-pc-msdosdjgpp-gcc
# You may have to specify STRIP/AR/RANLIB as well.
29 30 31
#
# Note for anyone editing this Makefile: gnumake will happily ignore any
# changes in this Makefile to variables set on the command line.
32
STRIP   ?= strip
33
INSTALL = install
34
DIFF    = diff
35
PREFIX  ?= /usr/local
36
MANDIR  ?= $(PREFIX)/share/man
37
CFLAGS  ?= -Os -Wall -Wshadow
38
EXPORTDIR ?= .
39
RANLIB  ?= ranlib
40 41
PKG_CONFIG ?= pkg-config
BUILD_DETAILS_FILE ?= build_details.txt
42

43 44 45 46 47 48 49 50 51 52 53 54
# The following parameter changes the default programmer that will be used if there is no -p/--programmer
# argument given when running flashrom. The predefined setting does not enable any default so that every
# user has to declare the programmer he wants to use on every run. The rationale for this to be not set
# (to e.g. the internal programmer) is that forgetting to specify this when working with another programmer
# easily puts the system attached to the default programmer at risk (e.g. you want to flash coreboot to another
# system attached to an external programmer while the default programmer is set to the internal programmer, and
# you forget to use the -p parameter. This would (try to) overwrite the existing firmware of the computer
# running flashrom). Please do not enable this without thinking about the possible consequences. Possible
# values are those specified in enum programmer in programmer.h (which depend on other CONFIG_* options
# evaluated below, namely those that enable/disable the various programmers).
# Compilation will fail for unspecified values.
CONFIG_DEFAULT_PROGRAMMER ?= PROGRAMMER_INVALID
55 56 57 58 59
# The following adds a default parameter for the default programmer set above (only).
CONFIG_DEFAULT_PROGRAMMER_ARGS ?= ''
# Example: compiling with
#   make CONFIG_DEFAULT_PROGRAMMER=PROGRAMMER_SERPROG CONFIG_DEFAULT_PROGRAMMER_ARGS="dev=/dev/ttyUSB0:1500000"
# would make executing './flashrom' (almost) equivialent to './flashrom -p serprog:dev=/dev/ttyUSB0:1500000'.
60

61 62
# If your compiler spits out excessive warnings, run make WARNERROR=no
# You shouldn't have to change this flag.
63 64 65 66 67 68
WARNERROR ?= yes

ifeq ($(WARNERROR), yes)
CFLAGS += -Werror
endif

69
ifdef LIBS_BASE
70
CPPFLAGS += -I$(LIBS_BASE)/include
71 72 73
LDFLAGS += -L$(LIBS_BASE)/lib -Wl,-rpath -Wl,$(LIBS_BASE)/lib
PKG_CONFIG_LIBDIR ?= $(LIBS_BASE)/lib/pkgconfig
endif
74

75 76 77 78 79
ifeq ($(CONFIG_STATIC),yes)
PKG_CONFIG += --static
LDFLAGS += -static
endif

80 81
dummy_for_make_3_80:=$(shell printf "Build started on %s\n\n" "$$(date)" >$(BUILD_DETAILS_FILE))
debug_shell = $(shell export LC_ALL=C ; { echo 'exec: export LC_ALL=C ; { $(1) ; }' >&2;  { $(1) ; } | tee -a $(BUILD_DETAILS_FILE) ; echo >&2 ; } 2>>$(BUILD_DETAILS_FILE))
82
###############################################################################
83 84 85 86
# General OS-specific settings.
# 1. Prepare for later by gathering information about host and target OS
# 2. Set compiler flags and parameters according to OSes
# 3. Likewise verify user-supplied CONFIG_* variables.
87

88
# HOST_OS is only used to work around local toolchain issues.
89
HOST_OS ?= $(shell uname)
90 91 92 93 94
ifeq ($(HOST_OS), MINGW32_NT-5.1)
# Explicitly set CC = gcc on MinGW, otherwise: "cc: command not found".
CC = gcc
endif
ifneq ($(HOST_OS), SunOS)
95 96
STRIP_ARGS = -s
endif
97

98
# Determine the destination OS.
99 100 101
# IMPORTANT: The following line must be placed before TARGET_OS is ever used
# (of course), but should come after any lines setting CC because the line
# below uses CC itself.
102
override TARGET_OS := $(strip $(call debug_shell,$(CC) $(CPPFLAGS) -E os.h 2>/dev/null | grep -v '^\#' | grep '"' | cut -f 2 -d'"'))
103 104

ifeq ($(TARGET_OS), Darwin)
105
CPPFLAGS += -I/opt/local/include -I/usr/local/include
106
LDFLAGS += -L/opt/local/lib -L/usr/local/lib
Stefan Reinauer's avatar
Stefan Reinauer committed
107
endif
108

109
ifeq ($(TARGET_OS), FreeBSD)
110
CPPFLAGS += -I/usr/local/include
111 112
LDFLAGS += -L/usr/local/lib
endif
113

114
ifeq ($(TARGET_OS), OpenBSD)
Carl-Daniel Hailfinger's avatar
Carl-Daniel Hailfinger committed
115 116 117
CPPFLAGS += -I/usr/local/include
LDFLAGS += -L/usr/local/lib
endif
118

Stefan Tauner's avatar
Stefan Tauner committed
119 120 121 122 123 124
ifeq ($(TARGET_OS), NetBSD)
CPPFLAGS += -I/usr/pkg/include
LDFLAGS += -L/usr/pkg/lib
endif

ifeq ($(TARGET_OS), DragonFlyBSD)
Stefan Tauner's avatar
Stefan Tauner committed
125 126
CPPFLAGS += -I/usr/local/include
LDFLAGS += -L/usr/local/lib
Stefan Tauner's avatar
Stefan Tauner committed
127 128
endif

129
ifeq ($(TARGET_OS), DOS)
130
EXEC_SUFFIX := .exe
131
# DJGPP has odd uint*_t definitions which cause lots of format string warnings.
132
CFLAGS += -Wno-format
Stefan Tauner's avatar
Stefan Tauner committed
133
LIBS += -lgetopt
134
# Bus Pirate, Serprog and PonyProg are not supported under DOS (missing serial support).
135 136 137 138 139 140 141 142 143 144
ifeq ($(CONFIG_BUSPIRATE_SPI), yes)
UNSUPPORTED_FEATURES += CONFIG_BUSPIRATE_SPI=yes
else
override CONFIG_BUSPIRATE_SPI = no
endif
ifeq ($(CONFIG_SERPROG), yes)
UNSUPPORTED_FEATURES += CONFIG_SERPROG=yes
else
override CONFIG_SERPROG = no
endif
145 146 147 148 149
ifeq ($(CONFIG_PONY_SPI), yes)
UNSUPPORTED_FEATURES += CONFIG_PONY_SPI=yes
else
override CONFIG_PONY_SPI = no
endif
150
# Dediprog, USB-Blaster, PICkit2 and FT2232 are not supported under DOS (missing USB support).
151 152 153 154 155 156 157 158 159 160
ifeq ($(CONFIG_DEDIPROG), yes)
UNSUPPORTED_FEATURES += CONFIG_DEDIPROG=yes
else
override CONFIG_DEDIPROG = no
endif
ifeq ($(CONFIG_FT2232_SPI), yes)
UNSUPPORTED_FEATURES += CONFIG_FT2232_SPI=yes
else
override CONFIG_FT2232_SPI = no
endif
161 162 163 164 165
ifeq ($(CONFIG_USBBLASTER_SPI), yes)
UNSUPPORTED_FEATURES += CONFIG_USBBLASTER_SPI=yes
else
override CONFIG_USBBLASTER_SPI = no
endif
166 167 168 169 170
ifeq ($(CONFIG_PICKIT2_SPI), yes)
UNSUPPORTED_FEATURES += CONFIG_PICKIT2_SPI=yes
else
override CONFIG_PICKIT2_SPI = no
endif
171
endif
172

173 174 175
# FIXME: Should we check for Cygwin/MSVC as well?
ifeq ($(TARGET_OS), MinGW)
EXEC_SUFFIX := .exe
176
# MinGW doesn't have the ffs() function, but we can use gcc's __builtin_ffs().
177
FLASHROM_CFLAGS += -Dffs=__builtin_ffs
178 179 180
# Some functions provided by Microsoft do not work as described in C99 specifications. This macro fixes that
# for MinGW. See http://sourceforge.net/apps/trac/mingw-w64/wiki/printf%20and%20scanf%20family */
FLASHROM_CFLAGS += -D__USE_MINGW_ANSI_STDIO=1
181 182 183 184 185 186 187 188 189 190 191 192 193 194 195 196 197 198 199 200 201 202 203 204 205 206 207 208 209 210 211 212 213 214
# libusb-win32/libftdi stuff is usually installed in /usr/local.
CPPFLAGS += -I/usr/local/include
LDFLAGS += -L/usr/local/lib
# For now we disable all PCI-based programmers on Windows/MinGW (no libpci).
ifeq ($(CONFIG_INTERNAL), yes)
UNSUPPORTED_FEATURES += CONFIG_INTERNAL=yes
else
override CONFIG_INTERNAL = no
endif
ifeq ($(CONFIG_RAYER_SPI), yes)
UNSUPPORTED_FEATURES += CONFIG_RAYER_SPI=yes
else
override CONFIG_RAYER_SPI = no
endif
ifeq ($(CONFIG_NIC3COM), yes)
UNSUPPORTED_FEATURES += CONFIG_NIC3COM=yes
else
override CONFIG_NIC3COM = no
endif
ifeq ($(CONFIG_GFXNVIDIA), yes)
UNSUPPORTED_FEATURES += CONFIG_GFXNVIDIA=yes
else
override CONFIG_GFXNVIDIA = no
endif
ifeq ($(CONFIG_SATASII), yes)
UNSUPPORTED_FEATURES += CONFIG_SATASII=yes
else
override CONFIG_SATASII = no
endif
ifeq ($(CONFIG_ATAHPT), yes)
UNSUPPORTED_FEATURES += CONFIG_ATAHPT=yes
else
override CONFIG_ATAHPT = no
endif
215 216 217 218 219
ifeq ($(CONFIG_ATAVIA), yes)
UNSUPPORTED_FEATURES += CONFIG_ATAVIA=yes
else
override CONFIG_ATAVIA = no
endif
Kyösti Mälkki's avatar
Kyösti Mälkki committed
220 221 222 223 224
ifeq ($(CONFIG_IT8212), yes)
UNSUPPORTED_FEATURES += CONFIG_IT8212=yes
else
override CONFIG_IT8212 = no
endif
225 226 227 228 229 230 231 232 233 234 235 236 237 238 239 240 241 242 243 244
ifeq ($(CONFIG_DRKAISER), yes)
UNSUPPORTED_FEATURES += CONFIG_DRKAISER=yes
else
override CONFIG_DRKAISER = no
endif
ifeq ($(CONFIG_NICREALTEK), yes)
UNSUPPORTED_FEATURES += CONFIG_NICREALTEK=yes
else
override CONFIG_NICREALTEK = no
endif
ifeq ($(CONFIG_NICNATSEMI), yes)
UNSUPPORTED_FEATURES += CONFIG_NICNATSEMI=yes
else
override CONFIG_NICNATSEMI = no
endif
ifeq ($(CONFIG_NICINTEL), yes)
UNSUPPORTED_FEATURES += CONFIG_NICINTEL=yes
else
override CONFIG_NICINTEL = no
endif
245 246 247 248 249
ifeq ($(CONFIG_NICINTEL_EEPROM), yes)
UNSUPPORTED_FEATURES += CONFIG_NICINTEL_EEPROM=yes
else
override CONFIG_NICINTEL_EEPROM = no
endif
250 251 252 253 254 255 256 257 258 259 260 261 262 263 264 265 266
ifeq ($(CONFIG_NICINTEL_SPI), yes)
UNSUPPORTED_FEATURES += CONFIG_NICINTEL_SPI=yes
else
override CONFIG_NICINTEL_SPI = no
endif
ifeq ($(CONFIG_OGP_SPI), yes)
UNSUPPORTED_FEATURES += CONFIG_OGP_SPI=yes
else
override CONFIG_OGP_SPI = no
endif
ifeq ($(CONFIG_SATAMV), yes)
UNSUPPORTED_FEATURES += CONFIG_SATAMV=yes
else
override CONFIG_SATAMV = no
endif
endif

267
ifeq ($(TARGET_OS), libpayload)
268 269 270 271
ifeq ($(MAKECMDGOALS),)
.DEFAULT_GOAL := libflashrom.a
$(info Setting default goal to libflashrom.a)
endif
272
FLASHROM_CFLAGS += -DSTANDALONE
273 274 275 276 277
ifeq ($(CONFIG_DUMMY), yes)
UNSUPPORTED_FEATURES += CONFIG_DUMMY=yes
else
override CONFIG_DUMMY = no
endif
278
# Bus Pirate, Serprog and PonyProg are not supported with libpayload (missing serial support).
279 280 281 282 283 284 285 286 287 288
ifeq ($(CONFIG_BUSPIRATE_SPI), yes)
UNSUPPORTED_FEATURES += CONFIG_BUSPIRATE_SPI=yes
else
override CONFIG_BUSPIRATE_SPI = no
endif
ifeq ($(CONFIG_SERPROG), yes)
UNSUPPORTED_FEATURES += CONFIG_SERPROG=yes
else
override CONFIG_SERPROG = no
endif
289 290 291 292 293
ifeq ($(CONFIG_PONY_SPI), yes)
UNSUPPORTED_FEATURES += CONFIG_PONY_SPI=yes
else
override CONFIG_PONY_SPI = no
endif
294
# Dediprog, USB-Blaster, PICkit2 and FT2232 are not supported with libpayload (missing libusb support)
295 296 297 298 299 300 301 302 303 304
ifeq ($(CONFIG_DEDIPROG), yes)
UNSUPPORTED_FEATURES += CONFIG_DEDIPROG=yes
else
override CONFIG_DEDIPROG = no
endif
ifeq ($(CONFIG_FT2232_SPI), yes)
UNSUPPORTED_FEATURES += CONFIG_FT2232_SPI=yes
else
override CONFIG_FT2232_SPI = no
endif
305 306 307 308 309
ifeq ($(CONFIG_USBBLASTER_SPI), yes)
UNSUPPORTED_FEATURES += CONFIG_USBBLASTER_SPI=yes
else
override CONFIG_USBBLASTER_SPI = no
endif
310 311 312 313 314
ifeq ($(CONFIG_PICKIT2_SPI), yes)
UNSUPPORTED_FEATURES += CONFIG_PICKIT2_SPI=yes
else
override CONFIG_PICKIT2_SPI = no
endif
315 316
endif

317 318 319 320 321 322
ifneq ($(TARGET_OS), Linux)
ifeq ($(CONFIG_LINUX_SPI), yes)
UNSUPPORTED_FEATURES += CONFIG_LINUX_SPI=yes
else
override CONFIG_LINUX_SPI = no
endif
323 324 325 326 327
ifeq ($(CONFIG_MSTARDDC_SPI), yes)
UNSUPPORTED_FEATURES += CONFIG_MSTARDDC_SPI=yes
else
override CONFIG_MSTARDDC_SPI = no
endif
328 329
endif

330 331 332 333
###############################################################################
# General architecture-specific settings.
# Like above for the OS, below we verify user-supplied options depending on the target architecture.

334 335 336
# Determine the destination processor architecture.
# IMPORTANT: The following line must be placed before ARCH is ever used
# (of course), but should come after any lines setting CC because the line
337
# below uses CC itself.
338
override ARCH := $(strip $(call debug_shell,$(CC) $(CPPFLAGS) -E archtest.c 2>/dev/null | grep -v '^\#' | grep '"' | cut -f 2 -d'"'))
339

Stefan Tauner's avatar
Stefan Tauner committed
340
# PCI port I/O support is unimplemented on PPC/MIPS/SPARC and unavailable on ARM.
341 342
# Right now this means the drivers below only work on x86.
ifneq ($(ARCH), x86)
343 344 345 346 347 348 349 350 351 352 353 354 355 356 357 358 359 360 361 362 363 364 365 366 367 368 369 370 371 372 373 374
ifeq ($(CONFIG_NIC3COM), yes)
UNSUPPORTED_FEATURES += CONFIG_NIC3COM=yes
else
override CONFIG_NIC3COM = no
endif
ifeq ($(CONFIG_NICREALTEK), yes)
UNSUPPORTED_FEATURES += CONFIG_NICREALTEK=yes
else
override CONFIG_NICREALTEK = no
endif
ifeq ($(CONFIG_NICNATSEMI), yes)
UNSUPPORTED_FEATURES += CONFIG_NICNATSEMI=yes
else
override CONFIG_NICNATSEMI = no
endif
ifeq ($(CONFIG_RAYER_SPI), yes)
UNSUPPORTED_FEATURES += CONFIG_RAYER_SPI=yes
else
override CONFIG_RAYER_SPI = no
endif
ifeq ($(CONFIG_ATAHPT), yes)
UNSUPPORTED_FEATURES += CONFIG_ATAHPT=yes
else
override CONFIG_ATAHPT = no
endif
ifeq ($(CONFIG_SATAMV), yes)
UNSUPPORTED_FEATURES += CONFIG_SATAMV=yes
else
override CONFIG_SATAMV = no
endif
endif

375 376 377
###############################################################################
# Flash chip drivers and bus support infrastructure.

Stefan Tauner's avatar
Stefan Tauner committed
378
CHIP_OBJS = jedec.o stm50.o w39.o w29ee011.o \
379
	sst28sf040.o 82802ab.o \
380
	sst49lfxxxc.o sst_fwhub.o flashchips.o spi.o spi25.o spi25_statusreg.o \
381
	opaque.o sfdp.o en29lv640b.o at45db.o
382

383 384
###############################################################################
# Library code.
385

Stefan Tauner's avatar
Stefan Tauner committed
386
LIB_OBJS = layout.o flashrom.o udelay.o programmer.o helpers.o
387

388 389
###############################################################################
# Frontend related stuff.
390

391
CLI_OBJS = cli_classic.o cli_output.o cli_common.o print.o
392

Stefan Tauner's avatar
Stefan Tauner committed
393
# Set the flashrom version string from the highest revision number of the checked out flashrom files.
394 395
# Note to packagers: Any tree exported with "make export" or "make tarball"
# will not require subversion. The downloadable snapshots are already exported.
Stefan Tauner's avatar
Stefan Tauner committed
396
SVNVERSION := $(shell ./util/getrevision.sh -u 2>/dev/null )
397

398
RELEASE := 0.9.8
Stefan Tauner's avatar
Stefan Tauner committed
399
VERSION := $(RELEASE)-$(SVNVERSION)
400
RELEASENAME ?= $(VERSION)
401 402

SVNDEF := -D'FLASHROM_VERSION="$(VERSION)"'
403

Stefan Tauner's avatar
Stefan Tauner committed
404 405
# Inform user if there is no meaningful version string. If there is version information from a VCS print
# something anyway because $(info...) will print a line break in any case which would look suspicious.
406 407 408
# The && between the echos is a workaround for old versions of GNU make that issue the error "unterminated
# variable reference" if a semicolon is used instead.
$(info $(shell ./util/getrevision.sh -c 2>/dev/null || echo "Files don't seem to be under version control." && \
Stefan Tauner's avatar
Stefan Tauner committed
409 410
	echo "Replacing all version templates with $(VERSION)." ))

411 412 413
###############################################################################
# Default settings of CONFIG_* variables.

414 415 416
# Always enable internal/onboard support for now.
CONFIG_INTERNAL ?= yes

Stefan Tauner's avatar
Stefan Tauner committed
417
# Always enable serprog for now.
418 419
CONFIG_SERPROG ?= yes

420 421 422
# RayeR SPIPGM hardware support
CONFIG_RAYER_SPI ?= yes

423 424 425
# PonyProg2000 SPI hardware support
CONFIG_PONY_SPI ?= yes

426 427 428
# Always enable 3Com NICs for now.
CONFIG_NIC3COM ?= yes

429 430
# Enable NVIDIA graphics cards. Note: write and erase do not work properly.
CONFIG_GFXNVIDIA ?= yes
431

432 433 434
# Always enable SiI SATA controllers for now.
CONFIG_SATASII ?= yes

435 436 437 438
# Highpoint (HPT) ATA/RAID controller support.
# IMPORTANT: This code is not yet working!
CONFIG_ATAHPT ?= no

439 440 441
# VIA VT6421A LPC memory support
CONFIG_ATAVIA ?= yes

442
# Always enable FT2232 SPI dongles for now.
443
CONFIG_FT2232_SPI ?= yes
444

445 446 447
# Always enable Altera USB-Blaster dongles for now.
CONFIG_USBBLASTER_SPI ?= yes

448 449 450
# MSTAR DDC support needs more tests/reviews/cleanups.
CONFIG_MSTARDDC_SPI ?= no

451 452 453
# Always enable PICkit2 SPI dongles for now.
CONFIG_PICKIT2_SPI ?= yes

454 455 456 457 458
# Always enable dummy tracing for now.
CONFIG_DUMMY ?= yes

# Always enable Dr. Kaiser for now.
CONFIG_DRKAISER ?= yes
459

460 461 462
# Always enable Realtek NICs for now.
CONFIG_NICREALTEK ?= yes

463 464 465
# Disable National Semiconductor NICs until support is complete and tested.
CONFIG_NICNATSEMI ?= no

466 467 468
# Always enable Intel NICs for now.
CONFIG_NICINTEL ?= yes

469 470 471
# Always enable SPI on Intel NICs for now.
CONFIG_NICINTEL_SPI ?= yes

472 473 474
# Always enable EEPROM on Intel NICs for now.
CONFIG_NICINTEL_EEPROM ?= yes

475 476 477
# Always enable SPI on OGP cards for now.
CONFIG_OGP_SPI ?= yes

478
# Always enable Bus Pirate SPI for now.
479
CONFIG_BUSPIRATE_SPI ?= yes
480

481 482 483
# Disable Dediprog SF100 until support is complete and tested.
CONFIG_DEDIPROG ?= no

484 485 486
# Always enable Marvell SATA controllers for now.
CONFIG_SATAMV ?= yes

487 488 489
# Enable Linux spidev interface by default. We disable it on non-Linux targets.
CONFIG_LINUX_SPI ?= yes

Kyösti Mälkki's avatar
Kyösti Mälkki committed
490 491 492
# Always enable ITE IT8212F PATA controllers for now.
CONFIG_IT8212 ?= yes

493
# Disable wiki printing by default. It is only useful if you have wiki access.
494
CONFIG_PRINT_WIKI ?= no
495

496 497 498 499 500 501 502
# Enable all features if CONFIG_EVERYTHING=yes is given
ifeq ($(CONFIG_EVERYTHING), yes)
$(foreach var, $(filter CONFIG_%, $(.VARIABLES)),\
	$(if $(filter no, $($(var))),\
		$(eval $(var)=yes)))
endif

503 504 505 506
# Bitbanging SPI infrastructure, default off unless needed.
ifeq ($(CONFIG_RAYER_SPI), yes)
override CONFIG_BITBANG_SPI = yes
else
507 508 509
ifeq ($(CONFIG_PONY_SPI), yes)
override CONFIG_BITBANG_SPI = yes
else
510 511 512 513 514 515
ifeq ($(CONFIG_INTERNAL), yes)
override CONFIG_BITBANG_SPI = yes
else
ifeq ($(CONFIG_NICINTEL_SPI), yes)
override CONFIG_BITBANG_SPI = yes
else
516 517 518
ifeq ($(CONFIG_OGP_SPI), yes)
override CONFIG_BITBANG_SPI = yes
else
519 520 521 522
CONFIG_BITBANG_SPI ?= no
endif
endif
endif
523
endif
524
endif
525

Sean Nelson's avatar
Sean Nelson committed
526 527 528 529 530 531 532 533 534 535 536 537 538 539 540 541 542
###############################################################################
# Handle CONFIG_* variables that depend on others set (and verified) above.

# The external DMI decoder (dmidecode) does not work in libpayload. Bail out if the internal one got disabled.
ifeq ($(TARGET_OS), libpayload)
ifeq ($(CONFIG_INTERNAL), yes)
ifeq ($(CONFIG_INTERNAL_DMI), no)
UNSUPPORTED_FEATURES += CONFIG_INTERNAL_DMI=no
else
override CONFIG_INTERNAL_DMI = yes
endif
endif
endif

# Use internal DMI/SMBIOS decoder by default instead of relying on dmidecode.
CONFIG_INTERNAL_DMI ?= yes

543 544
###############################################################################
# Programmer drivers and programmer support infrastructure.
545
# Depending on the CONFIG_* variables set and verified above we set compiler flags and parameters below.
546

547
FEATURE_CFLAGS += -D'CONFIG_DEFAULT_PROGRAMMER=$(CONFIG_DEFAULT_PROGRAMMER)'
548
FEATURE_CFLAGS += -D'CONFIG_DEFAULT_PROGRAMMER_ARGS="$(CONFIG_DEFAULT_PROGRAMMER_ARGS)"'
549

550
ifeq ($(CONFIG_INTERNAL), yes)
551
FEATURE_CFLAGS += -D'CONFIG_INTERNAL=1'
Sean Nelson's avatar
Sean Nelson committed
552
PROGRAMMER_OBJS += processor_enable.o chipset_enable.o board_enable.o cbtable.o internal.o
553
ifeq ($(ARCH), x86)
554
PROGRAMMER_OBJS += it87spi.o it85spi.o sb600spi.o amd_imc.o wbsio_spi.o mcp6x_spi.o
Sean Nelson's avatar
Sean Nelson committed
555 556 557 558
PROGRAMMER_OBJS += ichspi.o ich_descriptors.o dmi.o
ifeq ($(CONFIG_INTERNAL_DMI), yes)
FEATURE_CFLAGS += -D'CONFIG_INTERNAL_DMI=1'
endif
559 560
else
endif
561 562 563
NEED_PCI := yes
endif

564
ifeq ($(CONFIG_SERPROG), yes)
565
FEATURE_CFLAGS += -D'CONFIG_SERPROG=1'
566
PROGRAMMER_OBJS += serprog.o
567 568
NEED_SERIAL := yes
NEED_NET := yes
569
endif
570

571 572 573 574 575 576 577
ifeq ($(CONFIG_RAYER_SPI), yes)
FEATURE_CFLAGS += -D'CONFIG_RAYER_SPI=1'
PROGRAMMER_OBJS += rayer_spi.o
# Actually, NEED_PCI is wrong. NEED_IOPORT_ACCESS would be more correct.
NEED_PCI := yes
endif

578 579 580 581 582 583
ifeq ($(CONFIG_PONY_SPI), yes)
FEATURE_CFLAGS += -D'CONFIG_PONY_SPI=1'
PROGRAMMER_OBJS += pony_spi.o
NEED_SERIAL := yes
endif

584
ifeq ($(CONFIG_BITBANG_SPI), yes)
585
FEATURE_CFLAGS += -D'CONFIG_BITBANG_SPI=1'
586
PROGRAMMER_OBJS += bitbang_spi.o
587 588
endif

589
ifeq ($(CONFIG_NIC3COM), yes)
590
FEATURE_CFLAGS += -D'CONFIG_NIC3COM=1'
591
PROGRAMMER_OBJS += nic3com.o
592
NEED_PCI := yes
593
endif
594

595
ifeq ($(CONFIG_GFXNVIDIA), yes)
596
FEATURE_CFLAGS += -D'CONFIG_GFXNVIDIA=1'
597
PROGRAMMER_OBJS += gfxnvidia.o
598
NEED_PCI := yes
599 600
endif

601
ifeq ($(CONFIG_SATASII), yes)
602
FEATURE_CFLAGS += -D'CONFIG_SATASII=1'
603
PROGRAMMER_OBJS += satasii.o
604
NEED_PCI := yes
605 606
endif

607
ifeq ($(CONFIG_ATAHPT), yes)
608
FEATURE_CFLAGS += -D'CONFIG_ATAHPT=1'
609 610 611 612
PROGRAMMER_OBJS += atahpt.o
NEED_PCI := yes
endif

613 614 615 616 617 618
ifeq ($(CONFIG_ATAVIA), yes)
FEATURE_CFLAGS += -D'CONFIG_ATAVIA=1'
PROGRAMMER_OBJS += atavia.o
NEED_PCI := yes
endif

Kyösti Mälkki's avatar
Kyösti Mälkki committed
619 620 621 622 623 624
ifeq ($(CONFIG_IT8212), yes)
FEATURE_CFLAGS += -D'CONFIG_IT8212=1'
PROGRAMMER_OBJS += it8212.o
NEED_PCI := yes
endif

625
ifeq ($(CONFIG_FT2232_SPI), yes)
626
# This is a totally ugly hack.
627
FEATURE_CFLAGS += $(call debug_shell,grep -q "FTDISUPPORT := yes" .features && printf "%s" "-D'CONFIG_FT2232_SPI=1'")
628 629 630 631 632 633
NEED_FTDI := yes
PROGRAMMER_OBJS += ft2232_spi.o
endif

ifeq ($(CONFIG_USBBLASTER_SPI), yes)
# This is a totally ugly hack.
634
FEATURE_CFLAGS += $(call debug_shell,grep -q "FTDISUPPORT := yes" .features && printf "%s" "-D'CONFIG_USBBLASTER_SPI=1'")
635 636 637 638
NEED_FTDI := yes
PROGRAMMER_OBJS += usbblaster_spi.o
endif

639 640 641 642 643 644
ifeq ($(CONFIG_PICKIT2_SPI), yes)
FEATURE_CFLAGS += -D'CONFIG_PICKIT2_SPI=1'
PROGRAMMER_OBJS += pickit2_spi.o
NEED_USB := yes
endif

645
ifeq ($(NEED_FTDI), yes)
646 647 648
FTDILIBS := $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)" ; $(PKG_CONFIG) --libs libftdi1 || $(PKG_CONFIG) --libs libftdi || printf "%s" "-lftdi -lusb")
FEATURE_CFLAGS += $(call debug_shell,grep -q "FT232H := yes" .features && printf "%s" "-D'HAVE_FT232H=1'")
FTDI_INCLUDES := $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)" ; $(PKG_CONFIG) --cflags-only-I libftdi1)
Alexandru Gagniuc's avatar
Alexandru Gagniuc committed
649
FEATURE_CFLAGS += $(FTDI_INCLUDES)
650
FEATURE_LIBS += $(call debug_shell,grep -q "FTDISUPPORT := yes" .features && printf "%s" "$(FTDILIBS)")
651 652
# We can't set NEED_USB here because that would transform libftdi auto-enabling
# into a hard requirement for libusb, defeating the purpose of auto-enabling.
653 654 655
endif

ifeq ($(CONFIG_DUMMY), yes)
656
FEATURE_CFLAGS += -D'CONFIG_DUMMY=1'
657
PROGRAMMER_OBJS += dummyflasher.o
658 659 660
endif

ifeq ($(CONFIG_DRKAISER), yes)
661
FEATURE_CFLAGS += -D'CONFIG_DRKAISER=1'
662
PROGRAMMER_OBJS += drkaiser.o
663
NEED_PCI := yes
664
endif
665

666
ifeq ($(CONFIG_NICREALTEK), yes)
667
FEATURE_CFLAGS += -D'CONFIG_NICREALTEK=1'
668 669 670 671
PROGRAMMER_OBJS += nicrealtek.o
NEED_PCI := yes
endif

672 673 674 675 676 677
ifeq ($(CONFIG_NICNATSEMI), yes)
FEATURE_CFLAGS += -D'CONFIG_NICNATSEMI=1'
PROGRAMMER_OBJS += nicnatsemi.o
NEED_PCI := yes
endif

678 679 680 681 682 683
ifeq ($(CONFIG_NICINTEL), yes)
FEATURE_CFLAGS += -D'CONFIG_NICINTEL=1'
PROGRAMMER_OBJS += nicintel.o
NEED_PCI := yes
endif

684 685 686 687 688 689
ifeq ($(CONFIG_NICINTEL_SPI), yes)
FEATURE_CFLAGS += -D'CONFIG_NICINTEL_SPI=1'
PROGRAMMER_OBJS += nicintel_spi.o
NEED_PCI := yes
endif

690 691 692 693 694 695
ifeq ($(CONFIG_NICINTEL_EEPROM), yes)
FEATURE_CFLAGS += -D'CONFIG_NICINTEL_EEPROM=1'
PROGRAMMER_OBJS += nicintel_eeprom.o
NEED_PCI := yes
endif

696 697 698 699 700 701
ifeq ($(CONFIG_OGP_SPI), yes)
FEATURE_CFLAGS += -D'CONFIG_OGP_SPI=1'
PROGRAMMER_OBJS += ogp_spi.o
NEED_PCI := yes
endif

702 703
ifeq ($(CONFIG_BUSPIRATE_SPI), yes)
FEATURE_CFLAGS += -D'CONFIG_BUSPIRATE_SPI=1'
704
PROGRAMMER_OBJS += buspirate_spi.o
705
NEED_SERIAL := yes
706 707
endif

708
ifeq ($(CONFIG_DEDIPROG), yes)
709
FEATURE_CFLAGS += -D'CONFIG_DEDIPROG=1'
710
PROGRAMMER_OBJS += dediprog.o
711
NEED_USB := yes
712 713
endif

714 715 716 717 718 719
ifeq ($(CONFIG_SATAMV), yes)
FEATURE_CFLAGS += -D'CONFIG_SATAMV=1'
PROGRAMMER_OBJS += satamv.o
NEED_PCI := yes
endif

720
ifeq ($(CONFIG_LINUX_SPI), yes)
721
# This is a totally ugly hack.
722
FEATURE_CFLAGS += $(call debug_shell,grep -q "LINUX_SPI_SUPPORT := yes" .features && printf "%s" "-D'CONFIG_LINUX_SPI=1'")
723 724 725
PROGRAMMER_OBJS += linux_spi.o
endif

726 727
ifeq ($(CONFIG_MSTARDDC_SPI), yes)
# This is a totally ugly hack.
728
FEATURE_CFLAGS += $(call debug_shell,grep -q "LINUX_I2C_SUPPORT := yes" .features && printf "%s" "-D'CONFIG_MSTARDDC_SPI=1'")
729 730 731 732
NEED_LINUX_I2C := yes
PROGRAMMER_OBJS += mstarddc_spi.o
endif

733
ifeq ($(NEED_SERIAL), yes)
734
LIB_OBJS += serial.o
735
endif
736

737
ifeq ($(NEED_NET), yes)
738
ifeq ($(TARGET_OS), SunOS)
739 740
LIBS += -lsocket
endif
741 742 743
endif

ifeq ($(NEED_PCI), yes)
744
CHECK_LIBPCI = yes
745
FEATURE_CFLAGS += -D'NEED_PCI=1'
746
FEATURE_CFLAGS += $(call debug_shell,grep -q "OLD_PCI_GET_DEV := yes" .libdeps && printf "%s" "-D'OLD_PCI_GET_DEV=1'")
747

748
PROGRAMMER_OBJS += pcidev.o physmap.o hwaccess.o
749
ifeq ($(TARGET_OS), NetBSD)
750
# The libpci we want is called libpciutils on NetBSD and needs NetBSD libpci.
751
PCILIBS += -lpciutils -lpci
752
# For (i386|x86_64)_iopl(2).
753
PCILIBS += -l$(shell uname -p)
754
else
755

756
PCILIBS += -lpci
757

758
ifeq ($(TARGET_OS), OpenBSD)
Carl-Daniel Hailfinger's avatar
Carl-Daniel Hailfinger committed
759
# For (i386|amd64)_iopl(2).
760
PCILIBS += -l$(shell uname -m)
761 762 763
else
ifeq ($(TARGET_OS), Darwin)
# DirectHW framework can be found in the DirectHW library.
764
PCILIBS += -framework IOKit -framework DirectHW
Carl-Daniel Hailfinger's avatar
Carl-Daniel Hailfinger committed
765
endif
766
endif
Jonathan A. Kollasch's avatar
Jonathan A. Kollasch committed
767
endif
768 769
endif

770 771 772
ifeq ($(NEED_USB), yes)
CHECK_LIBUSB0 = yes
FEATURE_CFLAGS += -D'NEED_USB=1'
773
USBLIBS := $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)" ; $(PKG_CONFIG) --libs libusb || printf "%s" "-lusb")
774 775
endif

776
ifeq ($(CONFIG_PRINT_WIKI), yes)
777
FEATURE_CFLAGS += -D'CONFIG_PRINT_WIKI=1'
778
CLI_OBJS += print_wiki.o
779 780
endif

781
FEATURE_CFLAGS += $(call debug_shell,grep -q "UTSNAME := yes" .features && printf "%s" "-D'HAVE_UTSNAME=1'")
782

783
# We could use PULLED_IN_LIBS, but that would be ugly.
784
FEATURE_LIBS += $(call debug_shell,grep -q "NEEDLIBZ := yes" .libdeps && printf "%s" "-lz")
785

786
LIBFLASHROM_OBJS = $(CHIP_OBJS) $(PROGRAMMER_OBJS) $(LIB_OBJS)
787
OBJS = $(CLI_OBJS) $(LIBFLASHROM_OBJS)
788

789
all: hwlibs features $(PROGRAM)$(EXEC_SUFFIX) $(PROGRAM).8
790 791 792 793
ifeq ($(ARCH), x86)
	@+$(MAKE) -C util/ich_descriptors_tool/ TARGET_OS=$(TARGET_OS) EXEC_SUFFIX=$(EXEC_SUFFIX)
endif

794
$(PROGRAM)$(EXEC_SUFFIX): $(OBJS)
795
	$(CC) $(LDFLAGS) -o $(PROGRAM)$(EXEC_SUFFIX) $(OBJS) $(LIBS) $(PCILIBS) $(FEATURE_LIBS) $(USBLIBS)
796

797 798 799 800
libflashrom.a: $(LIBFLASHROM_OBJS)
	$(AR) rcs $@ $^
	$(RANLIB) $@

801 802 803 804
# TAROPTIONS reduces information leakage from the packager's system.
# If other tar programs support command line arguments for setting uid/gid of
# stored files, they can be handled here as well.
TAROPTIONS = $(shell LC_ALL=C tar --version|grep -q GNU && echo "--owner=root --group=root")
805

806
%.o: %.c .features
807
	$(CC) -MMD $(CFLAGS) $(CPPFLAGS) $(FLASHROM_CFLAGS) $(FEATURE_CFLAGS) $(SVNDEF) -o $@ -c $<
808

809 810
# Make sure to add all names of generated binaries here.
# This includes all frontends and libflashrom.
811
# We don't use EXEC_SUFFIX here because we want to clean everything.
812
clean:
813
	rm -f $(PROGRAM) $(PROGRAM).exe libflashrom.a *.o *.d $(PROGRAM).8 $(BUILD_DETAILS_FILE)
814
	@+$(MAKE) -C util/ich_descriptors_tool/ clean
815 816

distclean: clean
817
	rm -f .features .libdeps
818

819 820
strip: $(PROGRAM)$(EXEC_SUFFIX)
	$(STRIP) $(STRIP_ARGS) $(PROGRAM)$(EXEC_SUFFIX)
821

822 823 824 825 826 827 828 829 830 831 832 833 834
# to define test programs we use verbatim variables, which get exported
# to environment variables and are referenced with $$<varname> later

define COMPILER_TEST
int main(int argc, char **argv)
{
	(void) argc;
	(void) argv;
	return 0;
}
endef
export COMPILER_TEST

835
compiler: featuresavailable
836
	@printf "Checking for a C compiler... " | tee -a $(BUILD_DETAILS_FILE)
837
	@echo "$$COMPILER_TEST" > .test.c
838 839 840
	@{ { { { { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .test.c -o .test$(EXEC_SUFFIX) >&2 && \
		echo "found." || { echo "not found."; \
		rm -f .test.c .test$(EXEC_SUFFIX); exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
841
	@rm -f .test.c .test$(EXEC_SUFFIX)
842
	@printf "Target arch is "
843
	@# FreeBSD wc will output extraneous whitespace.
844
	@echo $(ARCH)|wc -w|grep -q '^[[:blank:]]*1[[:blank:]]*$$' ||	\
845 846
		( echo "unknown. Aborting."; exit 1)
	@printf "%s\n" '$(ARCH)'
847 848 849 850 851
	@printf "Target OS is "
	@# FreeBSD wc will output extraneous whitespace.
	@echo $(TARGET_OS)|wc -w|grep -q '^[[:blank:]]*1[[:blank:]]*$$' ||	\
		( echo "unknown. Aborting."; exit 1)
	@printf "%s\n" '$(TARGET_OS)'
852 853 854 855 856
ifeq ($(TARGET_OS), libpayload)
	@$(CC) --version 2>&1 | grep -q coreboot || \
		( echo "Warning: It seems you are not using coreboot's reference compiler."; \
		  echo "This might work but usually does not, please beware." )
endif
857

858 859 860
define LIBPCI_TEST
/* Avoid a failing test due to libpci header symbol shadowing breakage */
#define index shadow_workaround_index
Stefan Tauner's avatar
Stefan Tauner committed
861
#if !defined __NetBSD__
862
#include <pci/pci.h>
Stefan Tauner's avatar
Stefan Tauner committed
863 864 865
#else
#include <pciutils/pci.h>
#endif
866 867 868 869 870 871 872 873 874 875 876
struct pci_access *pacc;
int main(int argc, char **argv)
{
	(void) argc;
	(void) argv;
	pacc = pci_alloc();
	return 0;
}
endef
export LIBPCI_TEST

877 878 879 880 881 882 883 884 885 886 887 888 889 890 891 892 893 894 895 896 897
define PCI_GET_DEV_TEST
/* Avoid a failing test due to libpci header symbol shadowing breakage */
#define index shadow_workaround_index
#if !defined __NetBSD__
#include <pci/pci.h>
#else
#include <pciutils/pci.h>
#endif
struct pci_access *pacc;
struct pci_dev *dev = {0};
int main(int argc, char **argv)
{
	(void) argc;
	(void) argv;
	pacc = pci_alloc();
	dev = pci_get_dev(pacc, dev->domain, dev->bus, dev->dev, 1);
	return 0;
}
endef
export PCI_GET_DEV_TEST

898
define LIBUSB0_TEST
899 900 901 902
#include "platform.h"
#if IS_WINDOWS
#include <lusb0_usb.h>
#else
903
#include <usb.h>
904
#endif
905 906 907 908 909 910 911 912 913 914 915 916
int main(int argc, char **argv)
{
	(void) argc;
	(void) argv;
	usb_init();
	return 0;
}
endef
export LIBUSB0_TEST

hwlibs: compiler
	@printf "" > .libdeps
917
ifeq ($(CHECK_LIBPCI), yes)
918
	@printf "Checking for libpci headers... " | tee -a $(BUILD_DETAILS_FILE)
919
	@echo "$$LIBPCI_TEST" > .test.c
920 921 922
	@{ { { { { $(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o >&2 && \
		echo "found." || { echo "not found."; echo;			\
		echo "Please install libpci headers."; \
923
		echo "See README for more information."; echo;			\
924 925
		rm -f .test.c .test.o; exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
	@printf "Checking version of pci_get_dev... " | tee -a $(BUILD_DETAILS_FILE)
926
	@echo "$$PCI_GET_DEV_TEST" > .test.c
927
	@ { $(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o >&2 && \
928
		( echo "new version (including PCI domain parameter)."; echo "OLD_PCI_GET_DEV := no" >> .libdeps ) ||	\
929 930 931 932 933 934 935
		( echo "old version (without PCI domain parameter)."; echo "OLD_PCI_GET_DEV := yes" >> .libdeps ) } 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
	@printf "Checking if libpci is present and sufficient... " | tee -a $(BUILD_DETAILS_FILE)
	@{ { { { $(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(PCILIBS) 2>>$(BUILD_DETAILS_FILE) >&2 && \
		echo "yes." || { echo "no.";							\
		printf "Checking if libz+libpci are present and sufficient..." ; \
		{ $(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(PCILIBS) -lz >&2 && \
		echo "yes." && echo "NEEDLIBZ := yes" > .libdeps } || { echo "no."; echo;	\
936
		echo "Please install libpci (package pciutils) and/or libz.";			\
937
		echo "See README for more information."; echo;				\
938
		rm -f .test.c .test.o .test$(EXEC_SUFFIX); exit 1; }; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
939
	@rm -f .test.c .test.o .test$(EXEC_SUFFIX)
940 941
endif
ifeq ($(CHECK_LIBUSB0), yes)
942
	@printf "Checking for libusb-0.1/libusb-compat headers... " | tee -a $(BUILD_DETAILS_FILE)
943
	@echo "$$LIBUSB0_TEST" > .test.c
944 945
	@{ { { { { $(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o >&2 && \
		echo "found." || { echo "not found."; echo;				\
946 947
		echo "Please install libusb-0.1 headers or libusb-compat headers.";	\
		echo "See README for more information."; echo;				\
948 949 950 951
		rm -f .test.c .test.o; exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
	@printf "Checking if libusb-0.1 is usable... " | tee -a $(BUILD_DETAILS_FILE)
	@{ { { { { $(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(USBLIBS) >&2 && \
		echo "yes." || { echo "no.";						\
952 953
		echo "Please install libusb-0.1 or libusb-compat.";			\
		echo "See README for more information."; echo;				\
954
		rm -f .test.c .test.o .test$(EXEC_SUFFIX); exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
955
	@rm -f .test.c .test.o .test$(EXEC_SUFFIX)
956
endif
957

958 959
.features: features

960 961 962
# If a user does not explicitly request a non-working feature, we should
# silently disable it. However, if a non-working (does not compile) feature
# is explicitly requested, we should bail out with a descriptive error message.
963
# We also have to check that at least one programmer driver is enabled.
964
featuresavailable:
965 966 967 968 969
ifeq ($(PROGRAMMER_OBJS),)
	@echo "You have to enable at least one programmer driver!"
	@false
endif
ifneq ($(UNSUPPORTED_FEATURES), )
970 971 972 973
	@echo "The following features are unavailable on your machine: $(UNSUPPORTED_FEATURES)"
	@false
endif

974
define FTDI_TEST
975
#include <stdlib.h>
976 977 978 979 980 981 982 983 984 985 986
#include <ftdi.h>
struct ftdi_context *ftdic = NULL;
int main(int argc, char **argv)
{
	(void) argc;
	(void) argv;
	return ftdi_init(ftdic);
}
endef
export FTDI_TEST

987 988 989 990 991 992
define FTDI_232H_TEST
#include <ftdi.h>
enum ftdi_chip_type type = TYPE_232H;
endef
export FTDI_232H_TEST

993 994 995 996 997 998 999 1000 1001 1002 1003 1004 1005
define UTSNAME_TEST
#include <sys/utsname.h>
struct utsname osinfo;
int main(int argc, char **argv)
{
	(void) argc;
	(void) argv;
	uname (&osinfo);
	return 0;
}
endef
export UTSNAME_TEST

1006 1007 1008 1009 1010 1011 1012 1013 1014 1015 1016 1017 1018
define LINUX_SPI_TEST
#include <linux/types.h>
#include <linux/spi/spidev.h>

int main(int argc, char **argv)
{
	(void) argc;
	(void) argv;
	return 0;
}
endef
export LINUX_SPI_TEST

1019 1020 1021 1022 1023 1024 1025 1026 1027 1028 1029 1030 1031
define LINUX_I2C_TEST
#include <linux/i2c-dev.h>
#include <linux/i2c.h>

int main(int argc, char **argv)
{
	(void) argc;
	(void) argv;
	return 0;
}
endef
export LINUX_I2C_TEST

1032 1033
features: compiler
	@echo "FEATURES := yes" > .features.tmp
1034
ifeq ($(NEED_FTDI), yes)
1035
	@printf "Checking for FTDI support... " | tee -a $(BUILD_DETAILS_FILE)
1036
	@echo "$$FTDI_TEST" > .featuretest.c
1037 1038 1039 1040 1041 1042 1043 1044 1045 1046
	@ { $(CC) $(CPPFLAGS) $(CFLAGS) $(FTDI_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(FTDILIBS) $(LIBS) >&2 && \
	(	echo "found."; echo "FTDISUPPORT := yes" >> .features.tmp ; \
		printf "Checking for FT232H support in libftdi... " ; \
		echo "$$FTDI_232H_TEST" >> .featuretest.c ; \
		{ $(CC) $(CPPFLAGS) $(CFLAGS) $(FTDI_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(FTDILIBS) $(LIBS) >&2 && \
			( echo "found."; echo "FT232H := yes" >> .features.tmp ) ||	\
			( echo "not found."; echo "FT232H := no" >> .features.tmp ) } \
	) || \
	( echo "not found."; echo "FTDISUPPORT := no" >> .features.tmp ) } \
	2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
1047 1048
endif
ifeq ($(CONFIG_LINUX_SPI), yes)
1049
	@printf "Checking if Linux SPI headers are present... " | tee -a $(BUILD_DETAILS_FILE)
1050
	@echo "$$LINUX_SPI_TEST" > .featuretest.c
1051
	@ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
1052
		( echo "yes."; echo "LINUX_SPI_SUPPORT := yes" >> .features.tmp ) ||	\
1053 1054
		( echo "no."; echo "LINUX_SPI_SUPPORT := no" >> .features.tmp ) } \
		2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
1055 1056
endif
ifeq ($(NEED_LINUX_I2C), yes)
1057
	@printf "Checking if Linux I2C headers are present... " | tee -a $(BUILD_DETAILS_FILE)
1058
	@echo "$$LINUX_I2C_TEST" > .featuretest.c
1059
	@ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
1060
		( echo "yes."; echo "LINUX_I2C_SUPPORT := yes" >> .features.tmp ) ||	\
1061 1062
		( echo "no."; echo "LINUX_I2C_SUPPORT := no" >> .features.tmp ) } \
		2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
1063
endif
1064
	@printf "Checking for utsname support... " | tee -a $(BUILD_DETAILS_FILE)
1065
	@echo "$$UTSNAME_TEST" > .featuretest.c
1066
	@ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
1067
		( echo "found."; echo "UTSNAME := yes" >> .features.tmp ) ||	\
1068
		( echo "not found."; echo "UTSNAME := no" >> .features.tmp ) } 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
1069
	@$(DIFF) -q .features.tmp .features >/dev/null 2>&1 && rm .features.tmp || mv .features.tmp .features
1070
	@rm -f .featuretest.c .featuretest$(EXEC_SUFFIX)
1071

1072
$(PROGRAM).8: $(PROGRAM).8.tmpl
Stefan Tauner's avatar
Stefan Tauner committed
1073
	@sed -e '1 s#".*".*#"$(shell ./util/getrevision.sh -d $(PROGRAM).8.tmpl 2>/dev/null)" "$(VERSION)"#' <$< >$@
1074 1075

install: $(PROGRAM)$(EXEC_SUFFIX) $(PROGRAM).8
1076
	mkdir -p $(DESTDIR)$(PREFIX)/sbin
1077
	mkdir -p $(DESTDIR)$(MANDIR)/man8
1078
	$(INSTALL) -m 0755 $(PROGRAM)$(EXEC_SUFFIX) $(DESTDIR)$(PREFIX)/sbin
1079
	$(INSTALL) -m 0644 $(PROGRAM).8 $(DESTDIR)$(MANDIR)/man8
1080

1081
export: $(PROGRAM).8
1082 1083 1084
	@rm -rf $(EXPORTDIR)/flashrom-$(RELEASENAME)
	@svn export -r BASE . $(EXPORTDIR)/flashrom-$(RELEASENAME)
	@sed "s/^SVNVERSION.*/SVNVERSION := $(SVNVERSION)/" Makefile >$(EXPORTDIR)/flashrom-$(RELEASENAME)/Makefile
1085
	@cp $(PROGRAM).8 "$(EXPORTDIR)/flashrom-$(RELEASENAME)/$(PROGRAM).8"
1086 1087
	@LC_ALL=C svn log >$(EXPORTDIR)/flashrom-$(RELEASENAME)/ChangeLog
	@echo Exported $(EXPORTDIR)/flashrom-$(RELEASENAME)/
1088 1089

tarball: export
1090 1091 1092
	@tar cjf $(EXPORTDIR)/flashrom-$(RELEASENAME).tar.bz2 -C $(EXPORTDIR)/ $(TAROPTIONS) flashrom-$(RELEASENAME)/
	@rm -rf $(EXPORTDIR)/flashrom-$(RELEASENAME)
	@echo Created $(EXPORTDIR)/flashrom-$(RELEASENAME).tar.bz2
1093

1094
djgpp-dos: clean
1095 1096 1097
	make CC=i586-pc-msdosdjgpp-gcc STRIP=i586-pc-msdosdjgpp-strip
libpayload: clean
	make CC="CC=i386-elf-gcc lpgcc" AR=i386-elf-ar RANLIB=i386-elf-ranlib
1098

1099
.PHONY: all install clean distclean compiler hwlibs features export tarball djgpp-dos featuresavailable libpayload
1100

1101
-include $(OBJS:.o=.d)